
//
// Text
//

.text-monospace { font-family: $font-family-monospace !important; }

// Alignment

.text-justify  { text-align: justify !important; }
.text-wrap     { white-space: normal !important; }
.text-nowrap   { white-space: nowrap !important; }
.text-truncate { @include text-truncate(); }

// Responsive alignment

@each $breakpoint in map-keys($grid-breakpoints) {
  @include media-breakpoint-up($breakpoint) {
    $infix: breakpoint-infix($breakpoint, $grid-breakpoints);

    .text#{$infix}-left   { text-align: left    !important; }
    .text#{$infix}-right  { text-align: right   !important; }
    .text#{$infix}-center { text-align: center  !important; }
  }
}

// Transformation

.text-lowercase  { text-transform: lowercase  !important; }
.text-uppercase  { text-transform: uppercase  !important; }
.text-capitalize { text-transform: capitalize !important; }

// Weight and italics

.font-weight-light   { font-weight: $font-weight-light    !important; }
.font-weight-lighter { font-weight: $font-weight-lighter  !important; }
.font-weight-normal  { font-weight: $font-weight-normal   !important; }
.font-weight-medium  { font-weight: $font-weight-medium   !important; }
.font-weight-bold    { font-weight: $font-weight-bold     !important; }
.font-weight-bolder  { font-weight: $font-weight-bolder   !important; }
.font-italic         { font-style:  italic                !important; }

@each $key, $size in (light: $font-weight-light, normal: $font-weight-normal, bold: $font-weight-bold, bolder: $font-weight-bolder) {
  .font-weight-hover-#{$key} {
    &:hover {
      font-weight: $size;
    }
  }
}

// Sizes
.font-xs  { font-size: $font-size-xs !important; }
.font-sm  { font-size: $font-size-sm !important; }
.font-md  { font-size: $font-size-md !important; }
.font-lg  { font-size: $font-size-lg !important; }
.font-xl  { font-size: $font-size-xl !important; }
.font-2xl { font-size: 1.5rem        !important; }
.font-3xl { font-size: 1.75rem       !important; }
.font-4xl { font-size: 2rem          !important; }
.font-5xl { font-size: 2.5rem        !important; }

// Contextual colors

.text-white,
.text-hover-white:hover { color: $white !important; }

.text-black,
.text-hover-black:hover { color: $black !important; }

@each $color, $value in $theme-colors {
  @include text-emphasis-variant(".text-#{$color}", $value, true);
  @include text-emphasis-hover-variant(".text-hover-#{$color}", $value, true);
}

.text-body { color: $body-color !important; }
.text-muted { color: $text-muted !important; }

// Misc

.text-hide {
  @include text-hide($ignore-warning: true);
}

.text-decoration-none { text-decoration: none !important; }

.text-break {
  word-break: break-word !important; // IE & < Edge 18
  overflow-wrap: break-word !important;
}

// Reset

.text-reset { color: inherit !important; }

// Writing-mode

.text-vertical-rl {
  writing-mode: vertical-rl;
}

.text-vertical-lr {
  writing-mode: vertical-lr;
}

// line-heigh

.line-height-1 {
  line-height: 1;
}
